use master;
GO

/* Configure some options for better performance */

sp_configure 'show advanced options', 1;
GO

reconfigure;
GO

-- always use parallelized queries
sp_configure 'cost threshold for parallelism', 0;
GO

-- use all available processors
sp_configure 'max degree of parallelism', 0;
GO

-- run at default priority (set to 1 for high priority)
sp_configure 'priority boost', 0;
GO

reconfigure;
GO

/* Create 4 tempdb devices (equals the number of CPUs) */

-- time to run: 5 minutes

declare @file nvarchar(max);

select 
	@file = physical_name
from
	sys.master_files
where
	database_id = DB_ID('tempdb')
and
	name = 'tempdev';

if @file is not null
begin
	declare @basename nvarchar(max);	
	select @basename = SUBSTRING(@file, 0, PATINDEX('%.[mM][dD][fF]', @file));
	
	exec (N'
		ALTER DATABASE tempdb MODIFY FILE (
			NAME = N''tempdev'', 
			NEWNAME = N''tempdev1'',
			FILENAME = N''' + @basename + '1.mdf'',
			SIZE = 8GB, 
			FILEGROWTH = 10%
		);
	');
	
	exec (N'
		ALTER DATABASE [tempdb] ADD FILE ( 
			NAME = N''tempdev2'', 
			FILENAME = N''' + @basename + '2.mdf'',
			SIZE = 8GB, 
			FILEGROWTH = 10%
		);
	');

	exec (N'
		ALTER DATABASE [tempdb] ADD FILE ( 
			NAME = N''tempdev3'', 
			FILENAME = N''' + @basename + '3.mdf'',
			SIZE = 8GB, 
			FILEGROWTH = 10%
		);
	');

	exec (N'
		ALTER DATABASE [tempdb] ADD FILE ( 
			NAME = N''tempdev4'', 
			FILENAME = N''' + @basename + '4.mdf'',
			SIZE = 8GB, 
			FILEGROWTH = 10%
		);
	');
	
	ALTER DATABASE tempdb MODIFY FILE (
		NAME = N'templog', 
		SIZE = 10GB, 
		FILEGROWTH = 5GB
	);

end
